blob: 7c2e060ae770710ed7ed27d0aed4cfd2e8145810 [file] [log] [blame]
Lars Hjemli70c7ac22007-05-26 15:56:40 +02001#!/bin/sh
2#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +02003# git-submodules.sh: add, init, update or list git submodules
Lars Hjemli70c7ac22007-05-26 15:56:40 +02004#
5# Copyright (c) 2007 Lars Hjemli
6
Ping Yinf2dc06a2008-03-11 21:52:17 +08007USAGE="[--quiet] [--cached] \
Julien Danjou835a3ee2009-03-31 17:50:12 +02008[add [-b branch] <repo> <path>]|[status|init|update [-i|--init] [-N|--no-fetch]|summary [-n|--summary-limit <n>] [<commit>]] \
David Aguilar2327f612008-08-24 12:43:37 -07009[--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
Junio C Hamano8f321a32007-11-06 01:50:02 -080010OPTIONS_SPEC=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020011. git-sh-setup
Mark Levedahl98fcf842008-08-24 14:46:10 -040012. git-parse-remote
Lars Hjemli70c7ac22007-05-26 15:56:40 +020013require_work_tree
14
Junio C Hamano5c08dbb2008-01-15 02:48:45 -080015command=
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020016branch=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020017quiet=
18cached=
Fabian Franz31ca3ac2009-02-05 20:18:32 -020019nofetch=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020020
21#
22# print stuff on stdout unless -q was specified
23#
24say()
25{
26 if test -z "$quiet"
27 then
28 echo "$@"
29 fi
30}
31
Mark Levedahlf31a5222007-09-23 22:19:42 -040032# Resolve relative url by appending to parent's url
33resolve_relative_url ()
34{
Mark Levedahl98fcf842008-08-24 14:46:10 -040035 remote=$(get_default_remote)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -040036 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
Mark Levedahlf31a5222007-09-23 22:19:42 -040038 url="$1"
Mark Levedahl99b120a2008-08-21 19:54:01 -040039 remoteurl=${remoteurl%/}
Mark Levedahlf31a5222007-09-23 22:19:42 -040040 while test -n "$url"
41 do
42 case "$url" in
43 ../*)
44 url="${url#../}"
45 remoteurl="${remoteurl%/*}"
46 ;;
47 ./*)
48 url="${url#./}"
49 ;;
50 *)
51 break;;
52 esac
53 done
Mark Levedahl99b120a2008-08-21 19:54:01 -040054 echo "$remoteurl/${url%/}"
Mark Levedahlf31a5222007-09-23 22:19:42 -040055}
56
Lars Hjemli941987a2007-06-11 21:12:24 +020057#
David Aguilara7b32692008-08-22 00:30:50 -070058# Get submodule info for registered submodules
59# $@ = path to limit submodule list
60#
61module_list()
62{
Johannes Schindelin496917b2009-02-07 14:43:15 +010063 git ls-files --error-unmatch --stage -- "$@" | grep '^160000 '
David Aguilara7b32692008-08-22 00:30:50 -070064}
65
66#
Lars Hjemli941987a2007-06-11 21:12:24 +020067# Map submodule path to submodule name
68#
69# $1 = path
70#
71module_name()
72{
Junio C Hamano537601a2007-07-25 15:51:26 -070073 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
Chris Riddfe22e542008-06-11 14:09:19 +010074 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
Imran M Yousufa5099bb2008-05-15 13:42:58 +060075 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
Junio C Hamano537601a2007-07-25 15:51:26 -070076 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
Lars Hjemli941987a2007-06-11 21:12:24 +020077 test -z "$name" &&
78 die "No submodule mapping found in .gitmodules for path '$path'"
79 echo "$name"
80}
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020081
82#
83# Clone a submodule
84#
Junio C Hamano23a485e2008-01-15 02:35:49 -080085# Prior to calling, cmd_update checks that a possibly existing
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020086# path is not a git repository.
Junio C Hamano23a485e2008-01-15 02:35:49 -080087# Likewise, cmd_add checks that path does not exist at all,
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020088# since it is the location of a new submodule.
89#
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020090module_clone()
91{
92 path=$1
93 url=$2
94
95 # If there already is a directory at the submodule path,
96 # expect it to be empty (since that is the default checkout
97 # action) and try to remove it.
98 # Note: if $path is a symlink to a directory the test will
99 # succeed but the rmdir will fail. We might want to fix this.
100 if test -d "$path"
101 then
102 rmdir "$path" 2>/dev/null ||
103 die "Directory '$path' exist, but is neither empty nor a git repository"
104 fi
105
106 test -e "$path" &&
107 die "A file already exist at path '$path'"
108
109 git-clone -n "$url" "$path" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200110 die "Clone of '$url' into submodule path '$path' failed"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200111}
112
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200113#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200114# Add a new submodule to the working tree, .gitmodules and the index
115#
Mark Levedahlec05df32008-07-09 21:05:40 -0400116# $@ = repo path
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200117#
118# optional branch is stored in global branch variable
119#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800120cmd_add()
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200121{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800122 # parse $args after "submodule ... add".
123 while test $# -ne 0
124 do
125 case "$1" in
126 -b | --branch)
127 case "$2" in '') usage ;; esac
128 branch=$2
129 shift
130 ;;
131 -q|--quiet)
132 quiet=1
133 ;;
134 --)
135 shift
136 break
137 ;;
138 -*)
139 usage
140 ;;
141 *)
142 break
143 ;;
144 esac
145 shift
146 done
147
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200148 repo=$1
149 path=$2
150
Mark Levedahlec05df32008-07-09 21:05:40 -0400151 if test -z "$repo" -o -z "$path"; then
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200152 usage
153 fi
154
Mark Levedahlec05df32008-07-09 21:05:40 -0400155 # assure repo is absolute or relative to parent
156 case "$repo" in
157 ./*|../*)
158 # dereference source url relative to parent's url
159 realrepo=$(resolve_relative_url "$repo") || exit
160 ;;
161 *:*|/*)
162 # absolute url
163 realrepo=$repo
164 ;;
165 *)
166 die "repo URL: '$repo' must be absolute or begin with ./|../"
167 ;;
168 esac
169
Michael J Gruberdb75ada2009-03-03 16:08:21 +0100170 # normalize path:
171 # multiple //; leading ./; /./; /../; trailing /
172 path=$(printf '%s/\n' "$path" |
173 sed -e '
174 s|//*|/|g
175 s|^\(\./\)*||
176 s|/\./|/|g
177 :start
178 s|\([^/]*\)/\.\./||
179 tstart
180 s|/*$||
181 ')
Junio C Hamano5be60072007-07-02 22:52:14 -0700182 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200183 die "'$path' already exists in the index"
184
Mark Levedahld4264ca2008-03-04 20:15:02 -0500185 # perhaps the path exists and is already a git repo, else clone it
186 if test -e "$path"
187 then
Mark Levedahle9656472008-07-07 22:36:40 -0400188 if test -d "$path"/.git -o -f "$path"/.git
Mark Levedahld4264ca2008-03-04 20:15:02 -0500189 then
190 echo "Adding existing repo at '$path' to the index"
191 else
192 die "'$path' already exists and is not a valid git repo"
193 fi
Mark Levedahlc2f93912008-07-09 21:05:41 -0400194
195 case "$repo" in
196 ./*|../*)
197 url=$(resolve_relative_url "$repo") || exit
198 ;;
199 *)
200 url="$repo"
201 ;;
202 esac
203 git config submodule."$path".url "$url"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500204 else
Mark Levedahld4264ca2008-03-04 20:15:02 -0500205
206 module_clone "$path" "$realrepo" || exit
Ping Yinb9b378a2008-09-26 23:33:23 +0800207 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
Mark Levedahld4264ca2008-03-04 20:15:02 -0500208 die "Unable to checkout submodule '$path'"
209 fi
210
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200211 git add "$path" ||
212 die "Failed to add submodule '$path'"
213
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600214 git config -f .gitmodules submodule."$path".path "$path" &&
215 git config -f .gitmodules submodule."$path".url "$repo" &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200216 git add .gitmodules ||
217 die "Failed to register submodule '$path'"
218}
219
220#
Mark Levedahl19a31f92008-08-10 19:10:04 -0400221# Execute an arbitrary command sequence in each checked out
222# submodule
223#
224# $@ = command to execute
225#
226cmd_foreach()
227{
David Aguilara7b32692008-08-22 00:30:50 -0700228 module_list |
Mark Levedahl19a31f92008-08-10 19:10:04 -0400229 while read mode sha1 stage path
230 do
231 if test -e "$path"/.git
232 then
233 say "Entering '$path'"
234 (cd "$path" && eval "$@") ||
235 die "Stopping at '$path'; script returned non-zero status."
236 fi
237 done
238}
239
240#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200241# Register submodules in .git/config
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200242#
243# $@ = requested paths (default to all)
244#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800245cmd_init()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200246{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800247 # parse $args after "submodule ... init".
248 while test $# -ne 0
249 do
250 case "$1" in
251 -q|--quiet)
252 quiet=1
253 ;;
254 --)
255 shift
256 break
257 ;;
258 -*)
259 usage
260 ;;
261 *)
262 break
263 ;;
264 esac
265 shift
266 done
267
David Aguilara7b32692008-08-22 00:30:50 -0700268 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200269 while read mode sha1 stage path
270 do
Lars Hjemli211b7f12007-06-06 11:13:02 +0200271 # Skip already registered paths
Lars Hjemli941987a2007-06-11 21:12:24 +0200272 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700273 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200274 test -z "$url" || continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200275
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600276 url=$(git config -f .gitmodules submodule."$name".url)
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200277 test -z "$url" &&
Lars Hjemli941987a2007-06-11 21:12:24 +0200278 die "No url found for submodule path '$path' in .gitmodules"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200279
Mark Levedahlf31a5222007-09-23 22:19:42 -0400280 # Possibly a url relative to parent
281 case "$url" in
282 ./*|../*)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -0400283 url=$(resolve_relative_url "$url") || exit
Mark Levedahlf31a5222007-09-23 22:19:42 -0400284 ;;
285 esac
286
Junio C Hamano5be60072007-07-02 22:52:14 -0700287 git config submodule."$name".url "$url" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200288 die "Failed to register url for submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200289
Lars Hjemli941987a2007-06-11 21:12:24 +0200290 say "Submodule '$name' ($url) registered for path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200291 done
292}
293
294#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200295# Update each submodule path to correct revision, using clone and checkout as needed
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200296#
297# $@ = requested paths (default to all)
298#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800299cmd_update()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200300{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800301 # parse $args after "submodule ... update".
302 while test $# -ne 0
303 do
304 case "$1" in
305 -q|--quiet)
Pierre Habouzitd1f63a32008-07-21 20:15:59 +0200306 shift
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800307 quiet=1
308 ;;
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100309 -i|--init)
310 shift
311 cmd_init "$@" || return
312 ;;
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200313 -N|--no-fetch)
314 shift
315 nofetch=1
316 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800317 --)
318 shift
319 break
320 ;;
321 -*)
322 usage
323 ;;
324 *)
325 break
326 ;;
327 esac
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800328 done
329
David Aguilara7b32692008-08-22 00:30:50 -0700330 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200331 while read mode sha1 stage path
332 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200333 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700334 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200335 if test -z "$url"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200336 then
337 # Only mention uninitialized submodules when its
338 # path have been specified
339 test "$#" != "0" &&
Alexandre Julliard989206f2008-11-11 22:09:16 +0100340 say "Submodule path '$path' not initialized" &&
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100341 say "Maybe you want to use 'update --init'?"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200342 continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200343 fi
Lars Hjemli211b7f12007-06-06 11:13:02 +0200344
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100345 if ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli211b7f12007-06-06 11:13:02 +0200346 then
347 module_clone "$path" "$url" || exit
Lars Hjemlibf2d8242007-06-11 21:12:22 +0200348 subsha1=
349 else
H.Merijn Brand51884082007-12-04 22:45:16 +0000350 subsha1=$(unset GIT_DIR; cd "$path" &&
Junio C Hamano5be60072007-07-02 22:52:14 -0700351 git rev-parse --verify HEAD) ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200352 die "Unable to find current revision in submodule path '$path'"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200353 fi
354
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200355 if test "$subsha1" != "$sha1"
356 then
Ping Yinb9b378a2008-09-26 23:33:23 +0800357 force=
358 if test -z "$subsha1"
359 then
360 force="-f"
361 fi
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200362
363 if test -z "$nofetch"
364 then
365 (unset GIT_DIR; cd "$path" &&
366 git-fetch) ||
367 die "Unable to fetch in submodule path '$path'"
368 fi
369
370 (unset GIT_DIR; cd "$path" &&
371 git-checkout $force -q "$sha1") ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200372 die "Unable to checkout '$sha1' in submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200373
Lars Hjemli941987a2007-06-11 21:12:24 +0200374 say "Submodule path '$path': checked out '$sha1'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200375 fi
376 done
377}
378
Emil Medvebffe71f2007-06-26 18:40:58 -0500379set_name_rev () {
380 revname=$( (
H.Merijn Brand51884082007-12-04 22:45:16 +0000381 unset GIT_DIR
Emil Medvebffe71f2007-06-26 18:40:58 -0500382 cd "$1" && {
Junio C Hamano5be60072007-07-02 22:52:14 -0700383 git describe "$2" 2>/dev/null ||
384 git describe --tags "$2" 2>/dev/null ||
Mark Levedahlf669ac02008-04-14 22:48:06 -0400385 git describe --contains "$2" 2>/dev/null ||
386 git describe --all --always "$2"
Emil Medvebffe71f2007-06-26 18:40:58 -0500387 }
388 ) )
389 test -z "$revname" || revname=" ($revname)"
390}
Ping Yin28f9af52008-03-11 21:52:15 +0800391#
392# Show commit summary for submodules in index or working tree
393#
394# If '--cached' is given, show summary between index and given commit,
395# or between working tree and given commit
396#
397# $@ = [commit (default 'HEAD'),] requested paths (default all)
398#
399cmd_summary() {
Ping Yinf2dc06a2008-03-11 21:52:17 +0800400 summary_limit=-1
Ping Yind0f64dd2008-04-12 23:05:31 +0800401 for_status=
Emil Medvebffe71f2007-06-26 18:40:58 -0500402
Ping Yin28f9af52008-03-11 21:52:15 +0800403 # parse $args after "submodule ... summary".
404 while test $# -ne 0
405 do
406 case "$1" in
407 --cached)
408 cached="$1"
409 ;;
Ping Yind0f64dd2008-04-12 23:05:31 +0800410 --for-status)
411 for_status="$1"
412 ;;
Ping Yinf2dc06a2008-03-11 21:52:17 +0800413 -n|--summary-limit)
414 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
415 then
416 :
417 else
418 usage
419 fi
420 shift
421 ;;
Ping Yin28f9af52008-03-11 21:52:15 +0800422 --)
423 shift
424 break
425 ;;
426 -*)
427 usage
428 ;;
429 *)
430 break
431 ;;
432 esac
433 shift
434 done
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200435
Ping Yinf2dc06a2008-03-11 21:52:17 +0800436 test $summary_limit = 0 && return
437
Miklos Vajna30353a42008-12-03 14:26:52 +0100438 if rev=$(git rev-parse -q --verify "$1^0")
Ping Yin28f9af52008-03-11 21:52:15 +0800439 then
440 head=$rev
441 shift
442 else
443 head=HEAD
444 fi
445
446 cd_to_toplevel
447 # Get modified modules cared by user
448 modules=$(git diff-index $cached --raw $head -- "$@" |
Jeff King759ad192008-10-22 15:22:53 -0400449 egrep '^:([0-7]* )?160000' |
Ping Yin28f9af52008-03-11 21:52:15 +0800450 while read mod_src mod_dst sha1_src sha1_dst status name
451 do
452 # Always show modules deleted or type-changed (blob<->module)
453 test $status = D -o $status = T && echo "$name" && continue
454 # Also show added or modified modules which are checked out
455 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
456 echo "$name"
457 done
458 )
Ping Yin1cb639e2008-03-11 21:52:16 +0800459
Ping Yind0f64dd2008-04-12 23:05:31 +0800460 test -z "$modules" && return
461
Ping Yin1cb639e2008-03-11 21:52:16 +0800462 git diff-index $cached --raw $head -- $modules |
Jeff King759ad192008-10-22 15:22:53 -0400463 egrep '^:([0-7]* )?160000' |
Ping Yin1cb639e2008-03-11 21:52:16 +0800464 cut -c2- |
465 while read mod_src mod_dst sha1_src sha1_dst status name
466 do
467 if test -z "$cached" &&
468 test $sha1_dst = 0000000000000000000000000000000000000000
469 then
470 case "$mod_dst" in
471 160000)
472 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
473 ;;
474 100644 | 100755 | 120000)
475 sha1_dst=$(git hash-object $name)
476 ;;
477 000000)
478 ;; # removed
479 *)
480 # unexpected type
481 echo >&2 "unexpected mode $mod_dst"
482 continue ;;
483 esac
484 fi
485 missing_src=
486 missing_dst=
487
488 test $mod_src = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100489 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800490 missing_src=t
491
492 test $mod_dst = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100493 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800494 missing_dst=t
495
496 total_commits=
497 case "$missing_src,$missing_dst" in
498 t,)
499 errmsg=" Warn: $name doesn't contain commit $sha1_src"
500 ;;
501 ,t)
502 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
503 ;;
504 t,t)
505 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
506 ;;
507 *)
508 errmsg=
509 total_commits=$(
510 if test $mod_src = 160000 -a $mod_dst = 160000
511 then
512 range="$sha1_src...$sha1_dst"
513 elif test $mod_src = 160000
514 then
515 range=$sha1_src
516 else
517 range=$sha1_dst
518 fi
519 GIT_DIR="$name/.git" \
520 git log --pretty=oneline --first-parent $range | wc -l
521 )
Johannes Sixteed35592008-03-12 09:30:01 +0100522 total_commits=" ($(($total_commits + 0)))"
Ping Yin1cb639e2008-03-11 21:52:16 +0800523 ;;
524 esac
525
526 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
527 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
528 if test $status = T
529 then
530 if test $mod_dst = 160000
531 then
532 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
533 else
534 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
535 fi
536 else
537 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
538 fi
539 if test -n "$errmsg"
540 then
541 # Don't give error msg for modification whose dst is not submodule
542 # i.e. deleted or changed to blob
543 test $mod_dst = 160000 && echo "$errmsg"
544 else
545 if test $mod_src = 160000 -a $mod_dst = 160000
546 then
Ping Yinf2dc06a2008-03-11 21:52:17 +0800547 limit=
548 test $summary_limit -gt 0 && limit="-$summary_limit"
Ping Yin1cb639e2008-03-11 21:52:16 +0800549 GIT_DIR="$name/.git" \
Ping Yinf2dc06a2008-03-11 21:52:17 +0800550 git log $limit --pretty='format: %m %s' \
Ping Yin1cb639e2008-03-11 21:52:16 +0800551 --first-parent $sha1_src...$sha1_dst
552 elif test $mod_dst = 160000
553 then
554 GIT_DIR="$name/.git" \
555 git log --pretty='format: > %s' -1 $sha1_dst
556 else
557 GIT_DIR="$name/.git" \
558 git log --pretty='format: < %s' -1 $sha1_src
559 fi
560 echo
561 fi
562 echo
Ping Yind0f64dd2008-04-12 23:05:31 +0800563 done |
564 if test -n "$for_status"; then
565 echo "# Modified submodules:"
566 echo "#"
567 sed -e 's|^|# |' -e 's|^# $|#|'
568 else
569 cat
570 fi
Ping Yin28f9af52008-03-11 21:52:15 +0800571}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200572#
Lars Hjemli941987a2007-06-11 21:12:24 +0200573# List all submodules, prefixed with:
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200574# - submodule not initialized
575# + different revision checked out
576#
577# If --cached was specified the revision in the index will be printed
578# instead of the currently checked out revision.
579#
580# $@ = requested paths (default to all)
581#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800582cmd_status()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200583{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800584 # parse $args after "submodule ... status".
585 while test $# -ne 0
586 do
587 case "$1" in
588 -q|--quiet)
589 quiet=1
590 ;;
591 --cached)
592 cached=1
593 ;;
594 --)
595 shift
596 break
597 ;;
598 -*)
599 usage
600 ;;
601 *)
602 break
603 ;;
604 esac
605 shift
606 done
607
David Aguilara7b32692008-08-22 00:30:50 -0700608 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200609 while read mode sha1 stage path
610 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200611 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700612 url=$(git config submodule."$name".url)
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100613 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200614 then
615 say "-$sha1 $path"
616 continue;
617 fi
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200618 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200619 if git diff-files --quiet -- "$path"
620 then
Emil Medvebffe71f2007-06-26 18:40:58 -0500621 say " $sha1 $path$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200622 else
623 if test -z "$cached"
624 then
H.Merijn Brand51884082007-12-04 22:45:16 +0000625 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200626 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200627 fi
Emil Medvebffe71f2007-06-26 18:40:58 -0500628 say "+$sha1 $path$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200629 fi
630 done
631}
David Aguilar2327f612008-08-24 12:43:37 -0700632#
633# Sync remote urls for submodules
634# This makes the value for remote.$remote.url match the value
635# specified in .gitmodules.
636#
637cmd_sync()
638{
639 while test $# -ne 0
640 do
641 case "$1" in
642 -q|--quiet)
643 quiet=1
644 shift
645 ;;
646 --)
647 shift
648 break
649 ;;
650 -*)
651 usage
652 ;;
653 *)
654 break
655 ;;
656 esac
657 done
658 cd_to_toplevel
659 module_list "$@" |
660 while read mode sha1 stage path
661 do
662 name=$(module_name "$path")
663 url=$(git config -f .gitmodules --get submodule."$name".url)
Johan Herlandbaede9f2008-09-22 18:08:31 +0200664
665 # Possibly a url relative to parent
666 case "$url" in
667 ./*|../*)
668 url=$(resolve_relative_url "$url") || exit
669 ;;
670 esac
671
David Aguilar2327f612008-08-24 12:43:37 -0700672 if test -e "$path"/.git
673 then
674 (
675 unset GIT_DIR
676 cd "$path"
677 remote=$(get_default_remote)
678 say "Synchronizing submodule url for '$name'"
679 git config remote."$remote".url "$url"
680 )
681 fi
682 done
683}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200684
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800685# This loop parses the command line arguments to find the
686# subcommand name to dispatch. Parsing of the subcommand specific
687# options are primarily done by the subcommand implementations.
688# Subcommand specific options such as --branch and --cached are
689# parsed here as well, for backward compatibility.
690
691while test $# != 0 && test -z "$command"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200692do
693 case "$1" in
David Aguilar2327f612008-08-24 12:43:37 -0700694 add | foreach | init | update | status | summary | sync)
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800695 command=$1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200696 ;;
697 -q|--quiet)
698 quiet=1
699 ;;
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200700 -b|--branch)
701 case "$2" in
702 '')
703 usage
704 ;;
705 esac
706 branch="$2"; shift
707 ;;
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200708 --cached)
Ping Yin28f9af52008-03-11 21:52:15 +0800709 cached="$1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200710 ;;
711 --)
712 break
713 ;;
714 -*)
715 usage
716 ;;
717 *)
718 break
719 ;;
720 esac
721 shift
722done
723
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800724# No command word defaults to "status"
725test -n "$command" || command=status
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200726
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800727# "-b branch" is accepted only by "add"
728if test -n "$branch" && test "$command" != add
729then
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200730 usage
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800731fi
732
Ping Yin28f9af52008-03-11 21:52:15 +0800733# "--cached" is accepted only by "status" and "summary"
734if test -n "$cached" && test "$command" != status -a "$command" != summary
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800735then
736 usage
737fi
738
739"cmd_$command" "$@"